# frozen_string_literal: true

module Segmentor
  module Errors
    # NotificationError can be raised by a notification block to indicate that
    # the notification should not be sent.
    class NotificationError < StandardError
      attr_reader :target

      def initialize(target)
        @target = target
        super('Notification error')
      end
    end
  end
end
