# frozen_string_literal: true

module Segmentor
  module Errors
    # NoSessionError is raised when there is no active or relevant session
    class NoSessionError < StandardError; end

    # SessionStateError is raised when the session status is not valid or the
    # change requested for the status is invalid
    class SessionStateError < StandardError; end
  end
end
